# sha1.h File Reference

## Detailed Description

Copyright (C) 2006-2009, Paul Bakker <polarssl_maintainer at polarssl.org> All rights reserved.

Joined copyright on original XySSL code with: Christophe Devine

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation; either version 2 of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.

Definition in file sha1.h.

Go to the source code of this file.

## Data Structures
struct | sha1_context
| SHA-1 context structure. More...
## Functions
void | sha1 (unsigned char *input, int ilen, unsigned char output[20])
| Output = SHA-1( input buffer ).
int | sha1_file (char *path, unsigned char output[20])
| Output = SHA-1( file contents ).
void | sha1_finish (sha1_context *ctx, unsigned char output[20])
| SHA-1 final digest.
void | sha1_hmac (unsigned char *key, int keylen, unsigned char *input, int ilen, unsigned char output[20])
| Output = HMAC-SHA-1( hmac key, input buffer ).
void | sha1_hmac_finish (sha1_context *ctx, unsigned char output[20])
| SHA-1 HMAC final digest.
void | sha1_hmac_starts (sha1_context *ctx, unsigned char *key, int keylen)
| SHA-1 HMAC context setup.
void | sha1_hmac_update (sha1_context *ctx, unsigned char *input, int ilen)
| SHA-1 HMAC process buffer.
int | sha1_self_test (int verbose)
| Checkup routine.
void | sha1_starts (sha1_context *ctx)
| SHA-1 context setup.
void | sha1_update (sha1_context *ctx, unsigned char *input, int ilen)
| SHA-1 process buffer.

## Function Documentation

void sha1 | ( | unsigned char * | input,
|  | int | ilen,
|  | unsigned char | output[20] |
| ) |  |  |

Output = SHA-1( input buffer ).

Parameters:

  | input | buffer holding the data
  | ilen | length of the input data
  | output | SHA-1 checksum result

int sha1_file | ( | char * | path,
|  | unsigned char | output[20] |
| ) |  |  |

Output = SHA-1( file contents ).

Parameters:

  | path | input file name
  | output | SHA-1 checksum result

Returns:
  0 if successful, 1 if fopen failed, or 2 if fread failed

void sha1_finish | ( | sha1_context * | ctx,
|  | unsigned char | output[20] |
| ) |  |  |

SHA-1 final digest.

Parameters:

  | ctx | SHA-1 context
  | output | SHA-1 checksum result

void sha1_hmac | ( | unsigned char * | key,
|  | int | keylen,
|  | unsigned char * | input,
|  | int | ilen,
|  | unsigned char | output[20] |
| ) |  |  |

Output = HMAC-SHA-1( hmac key, input buffer ).

Parameters:

  | key | HMAC secret key
  | keylen | length of the HMAC key
  | input | buffer holding the data
  | ilen | length of the input data
  | output | HMAC-SHA-1 result

void sha1_hmac_finish | ( | sha1_context * | ctx,
|  | unsigned char | output[20] |
| ) |  |  |

SHA-1 HMAC final digest.

Parameters:

  | ctx | HMAC context
  | output | SHA-1 HMAC checksum result

void sha1_hmac_starts | ( | sha1_context * | ctx,
|  | unsigned char * | key,
|  | int | keylen |
| ) |  |  |

SHA-1 HMAC context setup.

Parameters:

  | ctx | HMAC context to be initialized
  | key | HMAC secret key
  | keylen | length of the HMAC key

void sha1_hmac_update | ( | sha1_context * | ctx,
|  | unsigned char * | input,
|  | int | ilen |
| ) |  |  |

SHA-1 HMAC process buffer.

Parameters:

  | ctx | HMAC context
  | input | buffer holding the data
  | ilen | length of the input data

int sha1_self_test | ( | int | verbose | ) |

Checkup routine.

Returns:
  0 if successful, or 1 if the test failed

void sha1_starts | ( | sha1_context * | ctx | ) |

SHA-1 context setup.

Parameters:

  | ctx | context to be initialized

void sha1_update | ( | sha1_context * | ctx,
|  | unsigned char * | input,
|  | int | ilen |
| ) |  |  |

SHA-1 process buffer.

Parameters:

  | ctx | SHA-1 context
  | input | buffer holding the data
  | ilen | length of the input data